Subject: bug#58309: [BUG Report] found a bug? followup

From: Frank Pursel <[email-masked]>
Date: Thu, 20 Oct 2022 07:11:47 -0700

In hindsight, these errors occurred while my local network had a
degradation that, no doubt, caused some file transfer interruptions.  I
think this is to blame for these problems -- but -- I believe this may
still point to opportunities to make guix file transfers more robust.
Interrupted file transfers should be detected and, queued for retry, and
not result in store corruption or reports of store corruption.  Perhaps
this problem occurs when incomplete file transfers are prematurely
committed to the store?

On Wed, Oct 19, 2022 at 10:32 AM Maxime Devos <[email-masked]>
wrote:

>
>
> On 05-10-2022 19:58, Frank Pursel wrote:
> > Performed another 'guix pull' to receive one more change which led to
> > the additional reporting:
> >
> > guile-ssh-0.15.1-debug  238KiB 227.0MiB/s 00:00 [##################]
> 100.0%
> > Backtrace::
> >            15 (primitive-load
> "/gnu/store/k76q0ikk8a7769b0d2b9y3jj2mpaywh0-compute-guix-derivation")
> > In ice-9/eval.scm:
> >      155:9 14 (_ _)
> >      159:9 13 (_ #(#(#(#(#(#(#(#(#(#(#(#(#(#(#(#(#<directory (guile-u?>
> ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?))
> > In ice-9/boot-9.scm:
> >      152:2 12 (with-fluid* _ _ _)
> >      152:2 11 (with-fluid* _ _ _)
> > In ./guix/store.scm:
> >    2165:24 10 (run-with-store #<store-connection 256.99 7f657621c140>
> #<procedure 7f656de87c80 at ./guix/self.scm:12?> ?)
> >     1993:8  9 (_ #<store-connection 256.99 7f657621c140>)
> > In ./guix/gexp.scm:
> >     300:22  8 (_ #<store-connection 256.99 7f657621c140>)
> >     1181:2  7 (_ #<store-connection 256.99 7f65668495f0>)
> >     1047:2  6 (_ #<store-connection 256.99 7f65668495f0>)
> >      893:4  5 (_ #<store-connection 256.99 7f65668495f0>)
> > In ./guix/store.scm:
> >    2050:12  4 (_ #<store-connection 256.99 7f65668495f0>)
> >    1402:13  3 (map/accumulate-builds #<store-connection 256.99
> 7f65668495f0> #<procedure 7f65618e48e0 at ./guix/stor?> ?)
> >     1398:5  2 (map/accumulate-builds #<store-connection 256.99
> 7f65668495f0> #<procedure 7f656a61b840 at ./guix/stor?> ?)
> >    1414:15  1 (_ #<store-connection 256.99 7f65668495f0>
> ("/gnu/store/063db2n6gr2pqvy77fxp82p0ki6vwklz-guile-avah?" ?) ?)
> >    1414:15  0 (loop #f)
> >
>
> Looks like a duplicate of the second part of
> <https://issues.guix.gnu.org/58149#0>,
> <https://issues.guix.gnu.org/53736#0> (*),
> <https://issues.guix.gnu.org/53904>, <https://issues.guix.gnu.org/53974>
> and <https://issues.guix.gnu.org/54708>.
>
> (*) I think this one is interesting, as it seems to indicate that build
> errors of packages aren't handled during "guix pull" -- there is a patch
> available for that, though not applied yet IIRC.
>
> Greetings,
> Maxime.
>